/*
 * Created on Mar 7, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author cslabuser
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import java.util.*;

public class CAI {

	/*
	 * What does this agent play?
	 */
	
	private int MyStrategy;
	int ABLIMIT;				// Depth limit
	boolean IAmBlack;
	
	/*
	 * DEBUG VARIABLE
	 */
	boolean DEBUG	= false;
	
	/*
	 * ALPHA BETA VARIABLE
	 */
	int Alpha, Beta;
	//final int INFINITY = 2147483645;
	final int INFINITY = 1000000;
	final int GOAL = -100000;

	/*
	 * STATS VARIABLE
	 */
	int SuccessorsExpanded = 0;
		
	/*
	 * TIME VARIABLE
	 */
	Date timeStarted;
	final int TIME_LIMIT = 20;			// Time limit of 60 sec
	
	int v;
	
	public CAI(int WhatIPlay, int DepthLimit, boolean BlackPlayer) {
		MyStrategy = WhatIPlay;
		switch(MyStrategy)
		{
			// Alpha beta
			case 0:
				ABLIMIT = DepthLimit;
				break;
			case 1:
				ABLIMIT = DepthLimit ;	
				break;
		}
		
		IAmBlack = BlackPlayer;
	}
	
	public boolean isBlack() {
		return IAmBlack;
	}
	
	public String Play (CBoard cBoard/*, int Which*/) {
		SuccessorsExpanded = 0;
		String Result = new String();
		
		timeStarted = new Date();
		System.out.println("....AI PLAYS....");
		System.out.println("Heuristic value before AI plays : " + heuristic(cBoard));
		/*
		switch (Which) {
			case 1:*/
				Result = AlphaBetaUgaBugaSearch(cBoard);
				cBoard.MakeMove(Result, false);
				/*break;
			case 2:
				
			
		}*/
		System.out.println("Heuristic value after AI plays : " + heuristic(cBoard));
		System.out.println("=== Stats of the AI: ");
		System.out.println("    Successors :" + SuccessorsExpanded);
		
		Date end = new Date();
		System.out.println("    Time :" + (end.getTime() - timeStarted.getTime())/1000.0);
		return Result;
	}
	
	
	
	
	private String AlphaBetaUgaBugaSearch(CBoard cBoard) {

		CBoard 	cTemp;
		int		MinVal = +INFINITY;
		int 	Val = 0;
		int 	MinIndex = 0;
		String 	CurrentMove;
		int		Best1stLevelMove = 0;
		
		int SuccessorsSize = 0;
		ArrayList Successors = cBoard.GetLegalMoves();
		
		/* We have only one possible move, so don't search you idiot */
		SuccessorsSize = Successors.size(); 
		if (SuccessorsSize == 1){
			System.out.println("[" + Successors.get(0).toString() +"]");
			return Successors.get(0).toString();}
		
		CQuickSort cQuickSort = new CQuickSort();
		
		// Save the Alpha Beta Limit to dynamically change it
		int 	SavedABLIMIT = ABLIMIT;
		int		StartIDS	= 0;			// Start IDS with node 0
		int[] 	IndexArraySearch = new int[SuccessorsSize];
		int[] 	IndexValues 	= new int[SuccessorsSize];
		
		// Init this array
		for(int a=0;a<SuccessorsSize;a++)
			IndexArraySearch[a] = a;					// First try is same as the default computation

		switch (MyStrategy) {
			case 0:
				System.out.println("ALPHA BETA");
				break;
			case 1:
				System.out.println("NEGASCOUT");
				break;		
		}
		
		int LowerBound = 0;
		// IDS Search
		// CURRENTLY NO IDS, JUST A NORMAL SEARCH...
		if(WhichPhaseIsIt(cBoard) == 2)
			LowerBound = 12;		// Starting game
		else if(WhichPhaseIsIt(cBoard) == 1)
			LowerBound = 10;
		else if(WhichPhaseIsIt(cBoard) == 0)
			LowerBound = 12;

		MinVal = +INFINITY;			
		for(ABLIMIT = LowerBound; ABLIMIT<=SavedABLIMIT;ABLIMIT++)
		{
			System.out.println("IDS level : " + ABLIMIT);
			int i = 0;

			// Classic search function
			for (int index = 0; index < SuccessorsSize; index++) {
				// Clone the current board
				cTemp = cBoard.Clone();
				
				// The new index is the index of the search array
				// Therefore, the search will start with the best move
				// This is the base to a search on a sort-based tree
				i = IndexArraySearch[index];
				
				// Get the current move
				CurrentMove = new String(Successors.get(i).toString());
	
				// Make the move
				cTemp.MakeMove(CurrentMove, false);
				
				// Compute the min value of the new successor
				switch (MyStrategy) {
					case 0:
						Val = MinValue(cTemp, Alpha, Beta, 0);
						break;
					
					case 1:
						Val = NegaScout(cTemp, Alpha, Beta, 0);
						break;		
				}
				
				// Saves the values
				IndexValues[index] = Val;
				IndexArraySearch[index] = index;
				 
				System.out.println("val : " + Val + "[" + CurrentMove +"]");

				if(Val == GOAL)
					System.out.println("-- I'M WINNING");
				if(Val == -GOAL)
					System.out.println("-- I'M LOSING");
					
				//System.out.println("Val ? MinVal ["+Val +":"+ MinVal+"]");					
				if(Val < MinVal){
					MinIndex = i;
					MinVal = Val;
					//System.out.println("MinVal :" + MinVal);
				}
				
				if(new Date().getTime() - timeStarted.getTime() > TIME_LIMIT * 1000){
					if(DEBUG) System.out.println("!!! v: (Time Limit hit)");

					break; 
				}
			}
			if(new Date().getTime() - timeStarted.getTime() > TIME_LIMIT * 1000){
				if(DEBUG) System.out.println("!!! v: (Time Limit hit)");

				break;				
			}

			int t1;

			System.out.println("Search array before quicksort:");
			// Place the best element at the beginning
			for(int a=0;a<SuccessorsSize;a++)
			{
				System.out.print(IndexArraySearch[a] + " ");
			}
			System.out.print("");
			for(int a=0;a<SuccessorsSize;a++)
			{
				System.out.print(IndexValues[a] + " ");
			}			

			// Quicksort the results so next time we'll start we the best last moves
			cQuickSort.sort(IndexArraySearch, IndexValues, 0, SuccessorsSize-1);
			
			System.out.println("Search array after quicksort :");
			// Place the best element at the beginning
			for(int a=0;a<SuccessorsSize;a++)
			{
				System.out.print(IndexArraySearch[a] + " ");
			}
			System.out.print("\n");
			for(int a=0;a<SuccessorsSize;a++)
			{
				System.out.print(IndexValues[a] + " ");
			}			

			System.out.println("\nBest move found : " + MinVal + "[" + Successors.get(MinIndex).toString() + "]");
			if(ABLIMIT == LowerBound)
				Best1stLevelMove = MinIndex;	
		}

		// Reload the saved ABLIMIT 
		ABLIMIT = SavedABLIMIT;		
						
		// Return the move bound to the min outcome
		//return Successors.get(MinIndex).toString();			
		return Successors.get(Best1stLevelMove).toString();
	}
	
	
	
	
	/*
	 * Test version of the NegaScout Algo: Doesn't work
	 */
	private int NegaScout(CBoard cBoard, int alpha, int beta, int Level)  
	{                        /* compute minimax value of position p */
		int a, b, t, i;
		/* leaf node */
		Date end = new Date();
		
		int Over = cBoard.TheGameIsOver();
		
		// Is the game over??
		if (Over != cBoard.NO)
		{
			if ( ((Over == cBoard.WHITE_WON) && !IAmBlack) 
				||((Over == cBoard.BLACK_WON) && IAmBlack) ) {		// It's me			-- good
				if(DEBUG) System.out.println("Game over -- I'M WINNING");
				cBoard.minmax = GOAL;		
				return cBoard.minmax;
			}
			else if ( ((Over == cBoard.WHITE_WON) && IAmBlack)
				|| ((Over == cBoard.BLACK_WON) && !IAmBlack)) {		// It's the opponent --bad
				if(DEBUG) System.out.println("Game over -- I'M LOSING");
				cBoard.minmax = -GOAL;
				return cBoard.minmax;
			}
			if(DEBUG) System.out.println("Game over -- DON'T KNOW WHAT's GOING ON");
		}

		if(Level >= ABLIMIT)
		{
			int h = heuristic(cBoard);
			cBoard.minmax = h;
			return h;
		}
		
		if(end.getTime() - timeStarted.getTime() > TIME_LIMIT * 1000){
			int h = heuristic(cBoard);
			cBoard.minmax = h;
			if(DEBUG) PrintTree("!!! v: (Time Limit hit)" + h, Level);

			return h; 
		}
		
		ArrayList Successors = GetSuccessors(cBoard);
		int SuccessorsSize = Successors.size();
		
		if( Successors.size() == 0 )
		{
			int h = heuristic(cBoard);
			cBoard.minmax = h;
			return h;
		}		   	
				                       
		a = -INFINITY;
		b = beta;
		
		//PrintTree("Black's move : " + cBoard.isBlacksMove(), ++Level);		
		for (i = 0; i < SuccessorsSize; i++ ) {
			
			t = -NegaScout( (CBoard)Successors.get(i), -b, -Math.max(a, alpha) , Level+1);
			
			if (t > a) {
				
				if ((b == beta) || (Level >= ABLIMIT-2))
					a = t;
				else
					a = -NegaScout( (CBoard)Successors.get(i), -beta, -t, Level+1);
				
				if (a >= beta) return a;
				
				b = Math.max(alpha, a) + 1;
				
			}
			
		}
	
		return a;
	}
	
	
	/*
	 * MaxValue : Part of the Alpha Beta Search
	 */
	private int MaxValue(CBoard cBoard, int iAlpha, int iBeta, int Level) {
		Date end = new Date();
		
		// Look for the goal state
		if(DEBUG) PrintTree("MAX Level " + Level, Level);

		int Over = cBoard.TheGameIsOver();
		
		if (Over != cBoard.NO)
		{
			if ( ((Over == cBoard.WHITE_WON) && !IAmBlack) 
				||((Over == cBoard.BLACK_WON) && IAmBlack) ) {		// It's me			-- good
				if(DEBUG) System.out.println("Game over -- I'M WINNING");
				cBoard.minmax = GOAL;		
				return cBoard.minmax;
			}
			else if ( ((Over == cBoard.WHITE_WON) && IAmBlack)
				|| ((Over == cBoard.BLACK_WON) && !IAmBlack)) {		// It's the opponent --bad
				if(DEBUG) System.out.println("Game over -- I'M LOSING");
				cBoard.minmax = -GOAL;
				return cBoard.minmax;
			}
			if(DEBUG) System.out.println("Game over -- DON'T KNOW WHAT's GOING ON");
		}
		

		/*
		if (Over == cBoard.WHITE_WON) {
			return GOAL;
			}
		else if (Over == cBoard.BLACK_WON){
			return -GOAL; 
		}*/
		
		// Time Limit Hit???
		if(end.getTime() - timeStarted.getTime() > TIME_LIMIT * 1000){
			int t = heuristic(cBoard);
			cBoard.minmax = t;
			if(DEBUG) PrintTree("!!! v: (Time Limit hit)" + t, Level);

			return t; 
		}
					
		// Evaluate the heuristic
		if (Level >= ABLIMIT) 
		{
			int t = heuristic(cBoard);
			cBoard.minmax = t;
			if(DEBUG) PrintTree("v: (Limit hit)" + t, Level);
			return t;
		}
			
		v = -INFINITY;
		
		ArrayList Successors = GetSuccessors(cBoard);
		Level++;
		
		for (int i = 0; i < Successors.size(); i++) {
			v = Math.max(v, MinValue((CBoard)Successors.get(i), Alpha, Beta, Level));
			cBoard.minmax = v;
			if(DEBUG) PrintTree("v: " + v, Level);
			if (v >= Beta) {if(DEBUG) PrintTree("--Pruned ", Level);
				return v;} 
			Alpha = Math.max(Alpha, v);
		}

		return v;
	}

	/*
	 * MinValue : Part of the Alpha Beta Search
	 */
	private int MinValue(CBoard cBoard, int iAlpha, int iBeta, int Level) {
		Date end = new Date();
				
		if(DEBUG) PrintTree("MIN Level " + Level, Level);
		
		int Over = cBoard.TheGameIsOver();

		if (Over != cBoard.NO)
		{
			if ( ((Over == cBoard.WHITE_WON) && !IAmBlack) 
				||((Over == cBoard.BLACK_WON) && IAmBlack) ) {		// It's me			-- good
				if(DEBUG) System.out.println("Game over -- I'M WINNING");
				cBoard.minmax = GOAL;		
				return cBoard.minmax;
			}
			else if ( ((Over == cBoard.WHITE_WON) && IAmBlack)
				|| ((Over == cBoard.BLACK_WON) && !IAmBlack)) {		// It's the opponent --bad
				if(DEBUG) System.out.println("Game over -- I'M LOSING");
				cBoard.minmax = -GOAL;
				return cBoard.minmax;
			}
			if(DEBUG) System.out.println("Game over -- DON'T KNOW WHAT's GOING ON");
		}
		// Look for the goal state
		/*if (Over == cBoard.WHITE_WON && !IAmBlack) {
			return GOAL;
			}
		else if (Over == cBoard.BLACK_WON){
			return -GOAL; 
		}*/

		// Time Limit Hit???
		if(end.getTime() - timeStarted.getTime() > TIME_LIMIT * 1000){
			int t = heuristic(cBoard);
			cBoard.minmax = t;
			if(DEBUG) PrintTree("!!! v: (Time Limit hit)" + t, Level);

			return t; 
		}

		// Evaluate the heuristic
		if (Level >= ABLIMIT){
			int t = heuristic(cBoard);
			cBoard.minmax = t;	
			if(DEBUG) PrintTree("v: (Limit hit)" + t, Level);
			return t; }
		
		v = +INFINITY;
		
		ArrayList Successors = GetSuccessors(cBoard);
		
		for (int i = 0; i < Successors.size(); i++) {
			v = Math.min(v, MaxValue((CBoard)Successors.get(i), Alpha, Beta, Level));
			cBoard.minmax = v;
			if(DEBUG) PrintTree("v: " + v, Level);
			if (v <= Alpha){ if(DEBUG) PrintTree("--Pruned ", Level); return v;}
			Beta = Math.min(Beta, v);
		}
		
		return v;
	}

	/*
	 * heuristic: Define a basic heuristic that counts the number of pieces on the board
	 */	
	 // Dumb heuristic : # white pieces - # black pieces
	public int heuristic(CBoard cBoard)
	{
		return smart(cBoard);
		/*switch(MyStrategy)
		{
			case 0:
				return dumb(cBoard);
			case 1:
				return smart(cBoard);
		}
		return 0;*/

	}
	
	// Dumb heuristic : # white pieces - # black pieces
   public int dumb(CBoard cBoard)
   {
	   int b=0, w=0;
		
	   /* Count the number of pieces on this board */
	   for(int a=1;a<=32;a++)
	   {
		   if(!cBoard.isEmpty(a) && cBoard.isBlack(a))
			   b++;
		   if(!cBoard.isEmpty(a) && !cBoard.isBlack(a))
			   w++;
	   }
	
	   // Depends on whose turn it is
	   return (w-b);
   }
	
	/*
	 * GetSuccessors : Get all the successors from the given board
	 */
	private ArrayList GetSuccessors(CBoard cBoard) {
		
		ArrayList SuccessorMoves = new ArrayList();
		ArrayList Successors = new ArrayList();
		CBoard TempBoard;
		
		SuccessorMoves = cBoard.GetLegalMoves();
		
		for (int i = 0; i < SuccessorMoves.size(); i++) {
			TempBoard = cBoard.Clone();
			TempBoard.HowDidIGetHere = SuccessorMoves.get(i).toString();
			TempBoard.MakeMove(TempBoard.HowDidIGetHere, false);
			Successors.add(TempBoard);
			SuccessorsExpanded++;
		}
				
		return Successors;
		
	}
	
	/*
	 * Print the current move with a tree-like display
	 */
	private void PrintTree(String s, int num)
	{
		for(int a=0;a<num;a++)
			System.out.print("    ");
		System.out.println(s);
		
	}
	
	/* =====================
	 * HEURISTIC DEFINITION
	 * =====================
	 */
	
	 
	 // Defines
	 final int[] 	MY_KING 	= {20,6,2};			// Values for a king piece for phase 1, 2 and 3
	 final int[] 	HIS_KING 	= {-10,-3,-1};			// Values for a king piece for phase 1, 2 and 3
	
	 // ### NOT IMPLEMENTED YET ==>
	 final int[]		BACKROW = {1,-1,-3};		// Values for the pieces in the back row
	 // ### NOT IMPLEMENTED YET <==
	
	 final int 		MY_PIECE 	= 20;				// Value of a piece
	 final int 		HIS_PIECE 	= -10;				// Value of a piece
	
	 // Phases are 24:PHASE1 / (PHASE1-1):PHASE2 / (PHASE2-1):0
	 final int		PHASE1	= 16;			// Phase1 pieces
	 final int		PHASE2	= 8;			// Phase2 pieces
	 int				Phase = 1;	 
	
	// If one of our pieces are in these positions, assign these values
	final int[] 	PLAYER_BOARD ={
		MY_KING[Phase],MY_KING[Phase], MY_KING[Phase],MY_KING[Phase],
		-5,		-6,		-6,		-6,
			-5, 	-5, 	-5, 	-4,
		-3,		-4,		-4,		-4,
			-3, 	-3, 	-3, 	-2,
		-1,		-2,		-2,		-2,
			-1, 	-1, 	-1, 	-0,
		3,		4,		4,		4,
		};
	// If one of the opponent's pieces are on these positions, assign these values
	final int[] 	OPPONENT_BOARD ={
			-4,		-4,		-4,		-3,
		0, 		1, 		1, 		1,
			2,		2,		2,		1,
		2, 		3, 		3, 		3,
			4,		4,		4,		3,
		4,	 	5, 		5, 		5,
			6,		6,		6,		5,
		-HIS_KING[Phase],-HIS_KING[Phase], -HIS_KING[Phase],-HIS_KING[Phase]
		};
		
	private int smart(CBoard cBoard)
	{
		// Heuristic value
		int HValue = 0;
		
		// In which phase are we???
		Phase = WhichPhaseIsIt(cBoard);
		
		// Analyse all the elements of the Board
		for(int a=1;a<=32;a++)
		{
			if(!cBoard.isEmpty(a))											// If not empty, analyze the board
			{
				// If we have a stones of ours
				if( (cBoard.isBlack(a) && isBlack())
				||	(!cBoard.isBlack(a)) && !isBlack() )
				{
					if(!cBoard.isPiece(a))	HValue += MY_KING[Phase];
					else
					{
						HValue += MY_PIECE;
						if(isBlack())									// Assume we are white and want to win
							HValue += -OPPONENT_BOARD[a-1];					// ... so if the agent is black, opponent
						else
							HValue += PLAYER_BOARD[a-1];						// else, that's us
					}
					
				}
				else	// It's one of the opponent's stones
				{
					if(!cBoard.isPiece(a))	HValue += HIS_KING[Phase];
					else
					{
						HValue += HIS_PIECE;
						if(isBlack())
							HValue += -PLAYER_BOARD[a-1];
						else
							HValue += OPPONENT_BOARD[a-1];
					}	
				}
				
			}
		}
		
		return HValue;
		
	}
	
	/*
	 * Which phase is it: We can be in phase 1,2 or 3 
	 */
	public int WhichPhaseIsIt(CBoard cBoard)
	{
		int whites = cBoard.NumOfWhiteStones();
		int blacks = cBoard.NumOfBlackStones();
		int p = 0;
		
		// Are we in phase 2?
		int diff = Math.abs(blacks - whites ); 		
		if( diff <= PHASE1)
		{
			// Are we in phase 3?
			if(diff <= PHASE2)	p = 2;		// Yes
			else				p = 1;		// No
		}
		
		return p;
	}
	 
	/*
	 * getPhase : return the phase in which we are playing
	 */
	public int getPhase() {return Phase;}
}
